plugin.GetOptionsPanel = function(self)

	-- Create Options Panel --
	optionsPanel = Turbine.UI.Control();
	optionsPanel:SetSize(500, 370);


	-- Options title --
	optionsPanelTitle = Turbine.UI.Label();
	optionsPanelTitle:SetParent(optionsPanel);
	optionsPanelTitle:SetText("Settings");
	optionsPanelTitle:SetSize(400, 30);
	optionsPanelTitle:SetPosition(0, 25);
	optionsPanelTitle:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsPanelTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	optionsPanelTitle:SetForeColor(Turbine.UI.Color.Yellow);
	optionsPanelTitle:SetFontStyle(Turbine.UI.FontStyle.Outline);
	optionsPanelTitle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	optionsPanelTitle:SetBackground(Turbine.UI.Graphic("RunekeeperAttunementDisplay/Images/optionsTitleBackground.tga"));


	-- Allow movement--
	option_allowMovement_label = Turbine.UI.Label();
	option_allowMovement_label:SetParent(optionsPanel);
	option_allowMovement_label:SetSize(300, 30);
	option_allowMovement_label:SetPosition(110, 70);
	option_allowMovement_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_allowMovement_label:SetText("Allow movement");
	option_allowMovement_label:SetForeColor(Turbine.UI.Color.White);
	option_allowMovement_checkbox = Turbine.UI.Lotro.CheckBox();
	option_allowMovement_checkbox:SetParent(optionsPanel);
	option_allowMovement_checkbox:SetSize(20, 20);
	option_allowMovement_checkbox:SetPosition(80, 69);
	option_allowMovement_checkbox:SetChecked(options["enableMovement"]);


	-- Display number --
	option_displayNumber_label = Turbine.UI.Label();
	option_displayNumber_label:SetParent(optionsPanel);
	option_displayNumber_label:SetSize(300, 30);
	option_displayNumber_label:SetPosition(110, 95);
	option_displayNumber_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_displayNumber_label:SetText("DisplayNumber");
	option_displayNumber_label:SetForeColor(Turbine.UI.Color.White);
	option_displayNumber_checkbox = Turbine.UI.Lotro.CheckBox();
	option_displayNumber_checkbox:SetParent(optionsPanel);
	option_displayNumber_checkbox:SetSize(20, 20);
	option_displayNumber_checkbox:SetPosition(80, 94);
	option_displayNumber_checkbox:SetChecked(options["displayNumber"]);


	-- Hide out of combat --
	option_hideOutOfCombat_label = Turbine.UI.Label();
	option_hideOutOfCombat_label:SetParent(optionsPanel);
	option_hideOutOfCombat_label:SetSize(300, 30);
	option_hideOutOfCombat_label:SetPosition(110, 120);
	option_hideOutOfCombat_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_hideOutOfCombat_label:SetText("Hide when out of combat");
	option_hideOutOfCombat_label:SetForeColor(Turbine.UI.Color.White);
	option_hideOutOfCombat_checkbox = Turbine.UI.Lotro.CheckBox();
	option_hideOutOfCombat_checkbox:SetParent(optionsPanel);
	option_hideOutOfCombat_checkbox:SetSize(20, 20);
	option_hideOutOfCombat_checkbox:SetPosition(80, 119);
	option_hideOutOfCombat_checkbox:SetChecked(options["hideOutOfCombat"]);


	-- AttunementBarLenght --
	option_attunementBarLenght_label = Turbine.UI.Label();
	option_attunementBarLenght_label:SetParent(optionsPanel);
	option_attunementBarLenght_label:SetSize(300, 30);
	option_attunementBarLenght_label:SetPosition(80, 150);
	option_attunementBarLenght_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_attunementBarLenght_label:SetText("Bar Lenght");
	option_attunementBarLenght_label:SetForeColor(Turbine.UI.Color.White);
	option_attunementBarLenght_textbox = Turbine.UI.Lotro.TextBox();
	option_attunementBarLenght_textbox:SetParent(optionsPanel);
	option_attunementBarLenght_textbox:SetMultiline(false);
	option_attunementBarLenght_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_attunementBarLenght_textbox:SetText(options["attunementBarLenght"]);
	option_attunementBarLenght_textbox:SetSize(100, 20);
	option_attunementBarLenght_textbox:SetPosition(80, 170);
	option_attunementBarLenght_textbox:SetZOrder(100);
	option_attunementBarLenght_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_attunementBarLenght_textbox:SetText(option_attunementBarLenght_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- AttunementBarHeight --
	option_attunementBarHeight_label = Turbine.UI.Label();
	option_attunementBarHeight_label:SetParent(optionsPanel);
	option_attunementBarHeight_label:SetSize(300, 30);
	option_attunementBarHeight_label:SetPosition(80, 200);
	option_attunementBarHeight_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_attunementBarHeight_label:SetText("Bar Height");
	option_attunementBarHeight_label:SetForeColor(Turbine.UI.Color.White);
	option_attunementBarHeight_textbox = Turbine.UI.Lotro.TextBox();
	option_attunementBarHeight_textbox:SetParent(optionsPanel);
	option_attunementBarHeight_textbox:SetMultiline(false);
	option_attunementBarHeight_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_attunementBarHeight_textbox:SetText(options["attunementBarHeight"]);
	option_attunementBarHeight_textbox:SetSize(100, 20);
	option_attunementBarHeight_textbox:SetPosition(80, 220);
	option_attunementBarHeight_textbox:SetZOrder(100);
	option_attunementBarHeight_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_attunementBarHeight_textbox:SetText(option_attunementBarHeight_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- AttunementBarGap --
	option_attunementBarGap_label = Turbine.UI.Label();
	option_attunementBarGap_label:SetParent(optionsPanel);
	option_attunementBarGap_label:SetSize(300, 30);
	option_attunementBarGap_label:SetPosition(80, 250);
	option_attunementBarGap_label:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_attunementBarGap_label:SetText("Bar Gap");
	option_attunementBarGap_label:SetForeColor(Turbine.UI.Color.White);
	option_attunementBarGap_textbox = Turbine.UI.Lotro.TextBox();
	option_attunementBarGap_textbox:SetParent(optionsPanel);
	option_attunementBarGap_textbox:SetMultiline(false);
	option_attunementBarGap_textbox:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	option_attunementBarGap_textbox:SetText(options["attunementBarGap"]);
	option_attunementBarGap_textbox:SetSize(100, 20);
	option_attunementBarGap_textbox:SetPosition(80, 270);
	option_attunementBarGap_textbox:SetZOrder(100);
	option_attunementBarGap_textbox.TextChanged = function (sender, args)
		-- Only allow numbers in textbox --
		option_attunementBarGap_textbox:SetText(option_attunementBarGap_textbox:GetText():gsub("[^0123456789]", ""));
	end


	-- Apply options button --
	apllyButton = Turbine.UI.Lotro.Button();
	apllyButton:SetText("Apply");
	apllyButton:SetParent(optionsPanel);
	apllyButton:SetSize(150, 20);
	apllyButton:SetPosition(80, 330);
	apllyButton:SetZOrder(100);
	apllyButton.Click = function( sender, args)

		options["enableMovement"] = option_allowMovement_checkbox:IsChecked();
		AttunementWindowClass.moveControl:SetMouseVisible(options["enableMovement"])

		options["hideOutOfCombat"] = option_hideOutOfCombat_checkbox:IsChecked();
		if (options["hideOutOfCombat"]) then
			AttunementWindowClass.localPlayer.InCombatChanged();
		else
			AttunementWindowClass:SetWantsUpdates(false)
			AttunementWindowClass:SetOpacity(1)
		end

		options["displayNumber"] = option_displayNumber_checkbox:IsChecked();
		AttunementWindowClass.Attunement_label:SetVisible(options["displayNumber"])

		if (option_attunementBarLenght_textbox:GetText() == "") then
			option_attunementBarLenght_textbox:SetText("0")
		end

		if (option_attunementBarHeight_textbox:GetText() == "") then
			option_attunementBarHeight_textbox:SetText("0")
		end

		if (option_attunementBarGap_textbox:GetText() == "") then
			option_attunementBarGap_textbox:SetText("0")
		end

		options["attunementBarLenght"] = option_attunementBarLenght_textbox:GetText();
		options["attunementBarHeight"] = option_attunementBarHeight_textbox:GetText();
		options["attunementBarGap"] = option_attunementBarGap_textbox:GetText();

		AttunementWindowClass:UpdateElements();

		notification("Options have been applied.");
	end

	
	-- Return View --
	return optionsPanel;
end